#!/bin/bash
# /usr/local/HistoriqueS-03.sh # version bêta
# Liens : /opt/local/bin/HistoriqueS, /opt/local/bin/HistoS.
# Note -- En français seulement, pour l'instant.
#
# Objectif : Rassembler divers historiques dans
# ------------ un menu facile à consulter.
#
# Requiert : aemenu, awk, date, less, replaceit, rev, split, urxvt.
#
# (c) musher0, 10 mars 2019. Rév. : 11-12 mars 2019.
# Licence « musher0 » --
# Je cède gratuitement, à quiconque ce script peut rendre
# service, le droit de l'utiliser. # Tous autres droits réservés.
#                                             ======================
# Si vous souhaitez diffuser ce script ou l'adapter à vos besoins,
# s.v.p. me contacter avant par MP sur le forum PuppyLinux afin
# de me présenter votre projet. Nous en discuterons.
#
# Encore à faire --
# -- incorporer d'autres terminaisons de langages informatiques
#        dans la section « scripts »;
# -- semblablement pour la section « textes »;
# -- créer des sections audio et vidéo.
####################################################
# set -xe # L'un ou l'autre
killall -q aemenu
# LC_ALL=C
cd /root/.local/share
HistoS=/usr/local/HistoS/HistoriqueS-03.sh
total=/usr/local/HistoS/total

# Vérifications
if [ "`cat /usr/local/HistoS/taille`" -ne "`ls -Algo recently-used.xbel | awk '{ print $3 }'`" ];then
     a=1
     ls -Algo recently-used.xbel | awk '{ print $3 }' > /usr/local/HistoS/taille
     cp -f recently-used.xbel recently-used.xbel.bak # Mesure de sécurité.
else
     a=0
fi

[ ! -f $total ] && b=1 || b=0

if [ "`cat /usr/local/HistoS/taille-script`" -ne "`ls -Algo $HistoS | awk '{ print $3 }'`" ];then
     c=1
     ls -Algo $HistoS | awk '{ print $3 }' > /usr/local/HistoS/taille-script
     cp -f $HistoS $HistoS.bak # Mesure de sécurité.
else
     c=0
fi

if [ "$a" = "1" -o "$b" = "1" -o "$c" = "1" ];then
     cp -f recently-used.xbel recently-used.xbel.bak # Mesure de sécurité.

# Ramasser
     awk -F"\"" '$1 ~ /href/ {print $2}' recently-used.xbel > liste

# Élaguer
     RPLCT=""
     RPLCT="replaceit --input=liste"
     $RPLCT "file:///" "/"
     $RPLCT "T%C3%A9l%C3%A9chargements" Downloads

## Trier, généralement, d'après le type de fichier.
     awk -F"/" '{print $NF,$0}' liste | sort > tri.temp
     cut -d " " -f 2 tri.temp > tri # Merci à François Rousseau, réponse no 12,
# https://stackoverflow.com/questions/3222810/sorting-on-the-last-field-of-a-line

     FignolMenu () {
echo "menu $Menu
     cmd \"~~~~~\" \" \"" > $Menu
     cat Parties >> $Menu
echo -e "\tcmd \"~~~~~\" \" \"
end\n"  >> $Menu; }

     CreeMenu () {
Menu=""
Menu="${type^}"
>$Menu
while read line;do
     if [ -f $line ];then # Le fichier est-il encore là ?
          P="`echo "$line" | awk -F"\/" '{ print $NF}'`"
          echo "cmd $P \"rox $line\"" >> $Menu
     fi
done < $type

Combien="`wc -l < $Menu`" # Créer des sous-menus au besoin.
if [  "$Combien" -ge "25" ];then # On coupe à 25 lignes.
     split -l 25 -d --numeric-suffixes=1 $Menu $Menu-
     ls -1 --file-type $Menu-* > liste
     > Parties
     n=1
     while read file; do
          echo "menu $Menu-$n
     cmd \"~~~~~\" \" \"" >> Parties
               cat $file >> Parties
          echo -e "\tcmd \"~~~~~\" \" \"
end\n"  >> Parties
          n="`expr $n + 1`"
     done < liste
else
     cat $Menu > Parties
fi ;}

     Traitement () {
CreeMenu
case "${type}" in
     scripts|textes) replaceit --input=Parties rox vis6a ;;
esac
FignolMenu; }

     for type in archives bdD images scripts tableurs textes;do
          case "${type}" in
               archives)awk -F"\." '$NF ~ /gz$|lz$|xz$|bz$|bz2$|extrait$|extracted$|lrzip$|lz4$|lzma$|lzo$|pet$|tar$|tgz$|zip$/' tri > $type
                    Traitement ;;
               bdD) awk -F"\." '$NF ~ /csv$|tsv$|db$|dbf$|sqlite$|xml$/ && $0 !~ /tmp/' tri > $type
                    Traitement ;;
               images) awk -F"\." '$NF ~ /bmp$|jpg$|jpeg$|png$|sdd$|tiff$|xpm$/' tri > $type
                    Traitement ;;
               scripts) awk -F"\." '$NF ~ /awk$|bas$|c$|conf$|cxx$|d$|desktop$|erl$|h$|java$|pas$|pl$|py$|rb$|rc$|sh$|vala$|^X\?e/ && $NF !~ /htm$|html$/ && $0 !~ /tmp/' tri > $type
                    Traitement ;;
               tableurs) awk -F"\." '$NF ~ /gnumeric$|ods$|sdc$|xls$|xlsx$j/' tri > $type
                     Traitement ;;
               textes) awk -F"\." '$NF ~ /1$|asc$|doc$|docx$|htm$|html$|md$|odt$|odf$|rtf$|specs$|tex$|txt$/ && $NF !~ /zip$/ && $0 !~ /tmp/' tri > $type
                    Traitement ;;
          esac
     done

# On rassemble le tout et on ajoute es éléments.
#     LC_ALL=""
     echo -e "cmd \"HistoriqueS\" HistoS
cmd \"~~~~~~~~~\" HistoS" > $total
#     LC_ALL=C
     cat Archives BdD Images Scripts Tableurs Textes >> $total
     echo "cmd \"~~~~~~~~~\" HistoS
menu Mtpaint
     cmd \"~~~~~\" \" \"" >> $total

     awk '$1 ~ /file/ { print $3 }' /root/.mtpaint > /root/mtpaint.lst
     awk -F"/" '{print $NF,$0}' /root/mtpaint.lst | sort > tri.temp
     cut -d " " -f 2 tri.temp > /root/mtpaint.lst

     while read file;do
          P="";if [ -f $file ];then
               P="`echo "$file" | awk -F"\/" '{ print $NF}'`"
               P="${P%.*}"
               echo "cmd $P \"rox $file\"" >> $total
          fi
     done < /root/mtpaint.lst
     echo "cmd \"~~~~~\" \" \"
end" >> $total

     echo "menu Système
     cmd \"~~~~~\" \" \"" >> $total
     Q=""
     for Q in /root/.bash_history /root/.history /root/.lesshst /root/.sqlite_history /var/log/cups/error_log /var/log/messages /var/log/previous.messages;do
          echo "cmd $Q \"/opt/local/bin/hst-gnl.sh $Q\"" >> $total
     done
     echo "menu xerrs-log
     cmd \"~~~~~\" \" \"
     cmd voir vis-xerrs_log
     cmd commutateur cmmttr-xerrs-log
     cmd \"~~~~~\" \" \"
end
cmd \"~~~~~\" \" \"
end
cmd \"~~~~~~~~~\" HistoS
menu Autres
     cmd \"~~~~~\" \" \"
     cmd \"La plupart des navigateurs et\" \" \"
     cmd \"applis sérieuses ont une entrée\" \" \"
     cmd \"ou un sous-menu d'historique.\" \" \"
     cmd \"Consultez-le ?\" \" \"
     cmd \"~~~~~\" \" \"
end
menu Utiles # Pour la commodité de la chose.
     cmd \"~~~~~\" \" \"
     cmd \" < Lancer\" console-tres-mince"  >> $total
if [ -d /opt/local/bin ];then
   echo "cmd \" Mes-applis\" \"rox /root/my-applications/bin /opt/local/bin\"" >> $total
else
   echo "cmd \" Mes-applis\" \"rox /root/my-applications/bin\"" >> $total
fi
  echo "cmd \" Mes-docs\" \"rox /root/my-documents\"
     menu \" Éditer...\"
          cmd \"~~~~~\" \" \"
          cmd \"... ce menu\" \"defaulttexteditor /opt/local/bin/HistoS\"
          cmd \"... .bashrc\" \"defaulttexteditor /root/.bashrc\"
          cmd \"... .Xdefaults\" \"defaulttexteditor /root/.Xdefaults\"
          cmd \"... .Xresources\" \"defaulttexteditor /root/.Xresources\"
          cmd \"~~~~~\" \" \"
     end
     cmd \" sqlite3\" /opt/local/bin/sqlite3.sh # Par ex.
     # pour étudier des BdD des navigateurs Mozilla.
     cmd \"~~~~~\" \" \"
end
cmd \"     ~~~~~~~~~\" HistoS" >> $total

# Nettoyage
     rm -f *.menu*
     for i in [Aa]rchives [Bb]dD [Ii]mages ordinaires Parties [Ss]cripts [Tt]ableurs [Tt]extes liste tri;do
          rm -f $i*
     done
     rm -f /root/mtpaint.lst
#     LC_ALL=""
fi

# Shoot!
aemenu -rc $total 2>/dev/null
# rm -f total # set +xe
