#!/bin/ash
# /root/my-applications/bin/visionner-xerrs_log-2b.sh
# (c) musher0, 14-16 janvier 2015; rév. 24 janv., 5 et 25 févr. 2015.
#
# Buts : suivre aisément et rapidement les comptes rendus d'erreur dans
# Puppy; filtrer les anomalies rapportées par X et auxquelles l'usager
# ne peut rien. /
# Goals: easily and quickly follow error reports in Puppy; filter anomalies
# reported by X and which the user can do nothing about.
#
# Utile aux : développeurs et utilisateurs avancés. /
# Useful for: developers and advanced users.
####
SansFlaFla="$@" # En option, pour argolance. ;-) # Si on lance le script
# avec < nb ou - > comme paramètre, l'info est affichée noir sur blanc.
# Ex. : < visionner-xerrs_log-2b.sh nb >.

splache (){
AFICH="/tmp/affiche"
case ${LANG:0:2} in	fr)BUR="Le fichier est déjà affiché";Non="déjà" ;;
	*)BUR="The file is already displayed";Non="already" ;; esac # Langue
echo " $BUR." > $AFICH

Geom="g 31x2+550-550"
CoLR="fg snow -bd #bebebe -cr snow -tr -tint grey90 -sh 101"
TRNSP="tr -tint AntiqueWhite1 -sh 91"
FNT="fn "xft:Monaco:pixelsize=16:autohint=true:antialias=true""
CADR="b 20 -w 8 +sb -bl" # Attention, paramètre "-bl" ! :-)

urxvt -$FNT -$Geom -$CoLR -$TRNSP -$CADR &>/dev/null -e less -p "$Non" -P "  ~~~~~~~~~~~~~~~~~~~~~~~~~  " -~ /$AFICH &
sleep 3s # On affiche.
kill -s 9 "`pidof -s less`" &>/dev/null & # On ferme
rm -f $AFICH # yaf-splash étant pitoyable...
} # Fonctions

xerrslog (){
[ -f /tmp/xerrs.less ] && rm -f /tmp/xerrs.less # préparation

# choix de l'éditeur
[ `which joe` ] && export EDITOR="/root/my-applications/bin/joel.sh /tmp/xerrs.log &>/dev/null" || export EDITOR="/usr/local/bin/defaulttexteditor /tmp/xerrs.log"

# Le SOMMAIRE du registre d'erreurs se charge dans l'éditeur en tapant 'v'. /
# The SUMMARY of the error log is loaded in the text editor by typing 'v'.

# Ligne de titre / Title line
[ ${LANG:0:2} = "fr" ] && lign="lignes" || lign="lines"
NLIGN="`wc -l /tmp/xerrs.log | awk -v l="$lign" '{ print $2"  -- ("$1" "l }'`"
poids="`ls -logh /tmp/xerrs.log | awk '{ print $3 }'`"

# messages pour / for less
#AIDE="       [ 'q',quitter  'h',aide  'g',début  'G',fin   'u',haut  'd', bas]       "
#HELP="         [ 'q',quit   'h',help   'g',top   'G',end   'u',up   'd',down ]       "
AIDE="[ 'q',quitter; 'h',aide; 'g',début; 'G',fin; 'u',haut; 'd',bas; 'v',xerrs\.log ]"
HELP="[ 'q',quit; 'h',help; 'g',top; 'G',end; 'u',up; 'd',down; 'v',xerrs\.log ]"
[ ${LANG:0:2} = "fr" ] && INFO="$AIDE" || INFO="$HELP"

PARAMLESS="c -j 25 -S -w -s -N -B -q" # param. less

case ${LANG:0:2} in fr)Ligne=" -=- Nx -===- Commande 'suspecte ou incorrecte' -===-" ;;
	*)Ligne=" -=- Nx -===- 'Suspicious or incorrect' command -===-" ;; esac

# Sommaire / Summary
echo -e "$Ligne\n`awk '!/board|charsets|Initializing|map|arning|xkbcomp|efinit|initrd|mational|acpi|appbar|UTF|ymbol|gtkrc|ROX|Terminated/' /tmp/xerrs.log | awk NF | uniq -c`\n$Ligne                     ¬¤¬" > /tmp/xerrs.less

# Copie le fichier avec en-tête, "pied de page" et filtres. Aussi, enlève
# les lignes vides et groupe les erreurs. Car xerrs.log est un fichier
# d'info NON éditable. /
# Copies file with header, footer and filters. Also removes empty lines
# and groups errors. Because the xerrs.log info file is NOT editable.

# afficher / display ## param. urxvt parms
Geom="g 92x20+165-165"
case "$SansFlaFla" in
	nb|-)COLR="bg white -fg black -cr black";TRNSP="";FNT="";CADR=""
# Si vous n'aimez pas le flafla. / # If you don't like bling. #
	urxvt -$COLR -T "Original : $NLIGN; $poids) --" -$Geom &>/dev/null -e less -$PARAMLESS -~ -p "¬¤¬" -P "     $INFO  " /tmp/xerrs.less ;;

	*)COLR="bg #2F4A3A -fg white -bd OrangeRed3 -cr white" # #542214"
	TRNSP="tr -tint AntiqueWhite1 -sh 49" # transparence
	FNT="fn xft:Monaco:pixelsize=13:antialias=true:autohint=true"
	CADR="b 20 -sr +st +tcw -sbt 14" # Param. d'urxvt
#
	rxvt -$COLR -T "Original : $NLIGN; $poids) --" -$FNT -$CADR -$TRNSP -$Geom &>/dev/null -e less -$PARAMLESS -p "¬¤¬" -P "   $INFO  " -~ /tmp/xerrs.less ;;
esac # Commande d'affichage
}

case "`ps | tr -s ' ' | awk '$4=="less" && $NF ~ /xerrs/'`" in
	"")xerrslog ;; # Ouvrir
	*)if [ -f /tmp/xerrslog.vu ];then
		kill -s 9 `ps | awk '$4=="less" && $NF ~ /less/ { print $1 }'`
		rm -f /tmp/xerrslog.vu # Fermer
	  else
		splache;echo vu > /tmp/xerrslog.vu # Avertir
	  fi ;;
esac ## Action (three-position / 'switch' / à 3 positions)
### 30 ###
